!
subroutine LA50(A, T)
!  C,    A.  A   
!      L  U    LA10
!declaration
real, intent(inout):: A(:,:)
integer, intent(in):: T(:)
real, allocatable:: W(:)
double precision Sum
integer i, j, k, m, n
!begin
  n=size(A,1)
  allocate(W(n))
  do i=1, n
    do j=i, n
      if (i==j) then
        Sum=1.D0
      else
        Sum=0.D0
        do k=i, j-1
          Sum=Sum-A(i,k)*dble(A(k,j))
        end do
      end if
      A(i,j)=sngl(Sum/A(j,j))
    end do
  end do
  do j=n-1, 1, -1
    do i=1, j
      Sum=dble(A(i,j))
      do k=j+1, n
        Sum=Sum-A(i,k)*dble(A(k,j))
      end do
      A(i,j)=sngl(Sum)
    end do
  end do
  do j=n-1, 1, -1
    do i=j+1, n
      Sum=0.D0
      do k=j+1, n
        Sum=Sum-A(i,k)*dble(A(k,j))
      end do
      W(i)=sngl(Sum)
    end do
    do i=j+1, n
      A(i,j)=W(i)
    end do
  end do
  do j=n-1, 1, -1
    m=T(j)
    if (m/=j) then
      W=A(:,j); A(:,j)=A(:,m); A(:,m)=W
    end if
  end do
  deallocate(W)
  return
end subroutine LA50
